/* a toolkitgroupview button in a toolkitgroup
 */

/*

    Copyright (C) 1991-2003 The National Gallery

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

/*

    These files are distributed with VIPS - http://www.vips.ecs.soton.ac.uk

*/

/* 
#define DEBUG
 */

#include "ip.h"

static ViewClass *parent_class = NULL;

static void
toolkitgroupview_destroy( GtkObject *object )
{
	Toolkitgroupview *kitgview;

#ifdef DEBUG
	printf( "toolkitgroupview_destroy\n" );
#endif /*DEBUG*/

	g_return_if_fail( object != NULL );
	g_return_if_fail( IS_TOOLKITGROUPVIEW( object ) );

	kitgview = TOOLKITGROUPVIEW( object );

	/* Instance destroy.
	 */

	GTK_OBJECT_CLASS( parent_class )->destroy( object );
}

static void 
toolkitgroupview_refresh( View *view )
{
	/* 
	Toolkitgroupview *kitgview = TOOLKITGROUPVIEW( view );
	 */

	/* FIXME ... should update display for reordering of toolkits (to keep
	 * menu sorted)
	 */

#ifdef DEBUG
	printf( "toolkitgroup changed\n" );
#endif /*DEBUG*/

	VIEW_CLASS( parent_class )->refresh( view );
}

static void
toolkitgroupview_class_init( ToolkitgroupviewClass *klass )
{
	GtkObjectClass *object_class = (GtkObjectClass *) klass;
	ViewClass *view_class = (ViewClass *) klass;

	parent_class = gtk_type_class( TYPE_VIEW );

	object_class->destroy = toolkitgroupview_destroy;

	/* Create signals.
	 */

	/* Set methods.
	 */
	view_class->refresh = toolkitgroupview_refresh;
}

static void
toolkitgroupview_init( Toolkitgroupview *kitgview )
{
	GtkWidget *swin;
	GtkWidget *viewport;
	GtkAdjustment *hadj, *vadj;

	swin = gtk_scrolled_window_new( NULL, NULL );
	gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW( swin ),
		GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC );
        gtk_box_pack_start( GTK_BOX( kitgview ), swin, TRUE, TRUE, 0 );
	gtk_widget_show( swin );

	hadj = gtk_scrolled_window_get_hadjustment( 
		GTK_SCROLLED_WINDOW( swin ) );
	vadj = gtk_scrolled_window_get_vadjustment( 
		GTK_SCROLLED_WINDOW( swin ) );
	viewport = gtk_viewport_new( hadj, vadj );
	gtk_viewport_set_shadow_type( GTK_VIEWPORT( viewport ),
		GTK_SHADOW_NONE );
	gtk_container_add( GTK_CONTAINER( swin ), viewport );
        gtk_widget_show( viewport );

        kitgview->menubar = gtk_menu_bar2_new();
	gtk_menu_bar2_set_shadow_type( GTK_MENU_BAR2( kitgview->menubar ),
		GTK_SHADOW_NONE );
	gtk_container_add( GTK_CONTAINER( viewport ), kitgview->menubar );
        gtk_widget_show( kitgview->menubar );
}

GtkType
toolkitgroupview_get_type( void )
{
	static GtkType toolkitgroupview_type = 0;

	if( !toolkitgroupview_type ) {
		static const GtkTypeInfo info = {
			"Toolkitgroupview",
			sizeof( Toolkitgroupview ),
			sizeof( ToolkitgroupviewClass ),
			(GtkClassInitFunc) toolkitgroupview_class_init,
			(GtkObjectInitFunc) toolkitgroupview_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL,
		};

		toolkitgroupview_type = gtk_type_unique( TYPE_VIEW, &info );
	}

	return( toolkitgroupview_type );
}

View *
toolkitgroupview_new( void )
{
	Toolkitgroupview *kitgview = gtk_type_new( TYPE_TOOLKITGROUPVIEW );

	return( VIEW( kitgview ) );
}

